BZOJ 1185 [HNOI2007]最小矩形覆盖:凸包 + 旋转卡壳
题目链接:https://www.lydsy.com/JudgeOnline/problem.php?id=1185
题意:
给出二维平面上的n个点,问你将所有点覆盖的最小矩形面积。
题解:
先找出凸包,然后旋转卡壳。
在旋转卡壳中有一个结论:最小覆盖矩形一定有一条边在凸包上。
所以先枚举矩形在凸包上的那条边(p[i],p[i+1]),然后利用单调性找出p[i]的对踵点p[u]。
至于左右两侧的切点p[l]和p[r],要利用它们连线在直线(p[i],p[i+1])上投影长度的单调性求出。
最后将找出的矩形顶点再做一遍极角排序即可。
AC Code:
#include <iostream>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <algorithm>
#define MAX_N 50005
#define INF_LF 1e14
#define EPS 1e-7 using namespace std; struct Coor
{
double x,y;
Coor(double _x,double _y) { x=_x,y=_y; }
Coor(){}
friend Coor operator + (const Coor &a,const Coor &b)
{
return Coor(a.x+b.x,a.y+b.y);
}
friend Coor operator - (const Coor &a,const Coor &b)
{
return Coor(a.x-b.x,a.y-b.y);
}
friend Coor operator * (const Coor &a,double b)
{
return Coor(a.x*b,a.y*b);
}
friend Coor operator / (const Coor &a,double b)
{
return Coor(a.x/b,a.y/b);
}
friend double len(const Coor &a,const Coor &b)
{
return sqrt((a.x-b.x)*(a.x-b.x)+(a.y-b.y)*(a.y-b.y));
}
friend double dot(const Coor &a,const Coor &b)
{
return a.x*b.x+a.y*b.y;
}
friend double cross(const Coor &a,const Coor &b)
{
return a.x*b.y-a.y*b.x;
}
friend double area(const Coor &a,const Coor &b,const Coor &c)
{
return fabs(cross(b-a,c-a));
}
friend double length(const Coor &a)
{
return sqrt(dot(a,a));
}
friend double pro(const Coor &a,const Coor &b)
{
return dot(a,b)/length(b);
}
friend Coor proc(const Coor &a,const Coor &b,const Coor &c)
{
Coor v=c-b;
return b+v*dot(v,a-b)/dot(v,v);
}
}; int n,tot=;
double ans=INF_LF;
Coor p[MAX_N];
Coor con[MAX_N];
Coor rect[MAX_N]; void read()
{
scanf("%d",&n);
for(int i=;i<=n;i++) scanf("%lf%lf",&p[i].x,&p[i].y);
} bool cmp(const Coor &a,const Coor &b)
{
double c=cross(a-p[],b-p[]);
return c!= ? c> : len(p[],a)<len(p[],b);
} inline bool eq(double x,double y)
{
return fabs(x-y)<EPS;
} void graham()
{
for(int i=;i<=n;i++)
{
if(p[i].y<p[].y || (p[i].y==p[].y && p[i].x<p[].x))
{
swap(p[i],p[]);
}
}
sort(p+,p++n,cmp);
con[++tot]=p[],con[++tot]=p[];
for(int i=;i<=n;i++)
{
while(tot>= && cross(con[tot]-con[tot-],p[i]-con[tot])<=) tot--;
con[++tot]=p[i];
}
} inline int mod(int x)
{
return ((x-)%tot+tot)%tot+;
} void rc()
{
int u=,l=,r=;
for(int i=;i<=tot;i++)
{
if(con[i].x<con[l].x || (con[i].x==con[l].x && con[i].y>con[l].y)) l=i;
if(con[i].x>con[r].x || (con[i].x==con[r].x && con[i].y<con[r].y)) r=i;
}
for(int i=;i<=tot;i++)
{
while(area(con[i],con[mod(i+)],con[u])<area(con[i],con[mod(i+)],con[mod(u+)])) u=mod(u+);
while(pro(con[r]-con[l],con[mod(i+)]-con[i])<pro(con[r]-con[mod(l+)],con[mod(i+)]-con[i])) l=mod(l+);
while(pro(con[r]-con[l],con[mod(i+)]-con[i])<pro(con[mod(r+)]-con[l],con[mod(i+)]-con[i])) r=mod(r+);
double w=pro(con[r]-con[l],con[mod(i+)]-con[i]);
double h=area(con[i],con[mod(i+)],con[u])/length(con[mod(i+)]-con[i]);
if(w*h<ans)
{
ans=w*h;
Coor v=con[mod(i+)]-con[i];
rect[]=proc(con[l],con[i],con[mod(i+)]);
rect[]=proc(con[r],con[i],con[mod(i+)]);
rect[]=proc(con[l],con[u],con[u]+v);
rect[]=proc(con[r],con[u],con[u]+v);
}
}
for(int i=;i<;i++)
{
if(rect[i].y<rect[].y || (rect[i].y==rect[].y && rect[i].x<rect[].x))
{
swap(rect[],rect[i]);
}
}
sort(rect+,rect+,cmp);
for(int i=;i<;i++)
{
if(eq(rect[i].x,)) rect[i].x=;
if(eq(rect[i].y,)) rect[i].y=;
}
} void work()
{
graham();
rc();
printf("%.5f\n",ans);
for(int i=;i<;i++) printf("%.5f %.5f\n",rect[i].x,rect[i].y);
} int main()
{
read();
work();
}
BZOJ 1185 [HNOI2007]最小矩形覆盖:凸包 + 旋转卡壳的更多相关文章
- bzoj 1185 [HNOI2007]最小矩形覆盖 凸包+旋转卡壳
题目大意 用最小矩形覆盖平面上所有的点 分析 有一结论:最小矩形中有一条边在凸包的边上,不然可以旋转一个角度让面积变小 简略证明 我们逆时针枚举一条边 用旋转卡壳维护此时最左,最右,最上的点 注意 注 ...
- [BZOJ1185][HNOI2007]最小矩形覆盖-[凸包+旋转卡壳]
Description 传送门 Solution 感性理解一下,最小矩形一定是由一条边和凸包上的边重合的. 然后它就是模板题了..然而真的好难调,小于大于动不动就打错. Code #include&l ...
- 洛谷 P3187 BZOJ 1185 [HNOI2007]最小矩形覆盖 (旋转卡壳)
题目链接: 洛谷 P3187 [HNOI2007]最小矩形覆盖 BZOJ 1185: [HNOI2007]最小矩形覆盖 Description 给定一些点的坐标,要求求能够覆盖所有点的最小面积的矩形, ...
- BZOJ 1185: [HNOI2007]最小矩形覆盖 [旋转卡壳]
1185: [HNOI2007]最小矩形覆盖 Time Limit: 10 Sec Memory Limit: 162 MBSec Special JudgeSubmit: 1435 Solve ...
- BZOJ:1185: [HNOI2007]最小矩形覆盖
1185: [HNOI2007]最小矩形覆盖 这计算几何……果然很烦…… 发现自己不会旋转卡壳,补了下,然后发现求凸包也不会…… 凸包:找一个最左下的点,其他点按照与它连边的夹角排序,然后维护一个栈用 ...
- BZOJ1185[HNOI2007] 最小矩形覆盖(旋转卡壳)
BZOJ1185[HNOI2007] 最小矩形覆盖 题面 给定一些点的坐标,要求求能够覆盖所有点的最小面积的矩形,输出所求矩形的面积和四个顶点的坐标 分析 首先可以先求凸包,因为覆盖了凸包上的顶点,凸 ...
- bzoj 1185 [HNOI2007]最小矩形覆盖——旋转卡壳
题目:https://www.lydsy.com/JudgeOnline/problem.php?id=1185 矩形一定贴着凸包的一条边.不过只是感觉这样. 枚举一条边,对面的点就是正常的旋转卡壳. ...
- BZOJ 1185: [HNOI2007]最小矩形覆盖-旋转卡壳法求点集最小外接矩形(面积)并输出四个顶点坐标-备忘板子
来源:旋转卡壳法求点集最小外接矩形(面积)并输出四个顶点坐标 BZOJ又崩了,直接贴一下人家的代码. 代码: #include"stdio.h" #include"str ...
- ●BZOJ 1185 [HNOI2007]最小矩形覆盖
题链: http://www.lydsy.com/JudgeOnline/problem.php?id=1185 题解: 计算几何,凸包,旋转卡壳 结论:矩形的某一条边在凸包的一条边所在的直线上. ( ...
随机推荐
- delphi 遇到问题、报错等
解决方法:using Windows
- centos7.3下使用yum 安装pip
centos下安装pip时失败: No package pip available.Error: Nothing to do 解决方法: 需要先安装扩展源EPEL. EPEL(http://fedor ...
- php5.4 的 php-fpm 的重启
php 5.3.3以后 源码中已经内嵌了 php-fpm,不用象以前的php版本一样专门打补丁了,只需要在configure的时候添加编译参数即可. 关于php-fpm的编译参数有 –enable-f ...
- XML 之快速入门
XML 简介 - XML, 即可扩展标记语言(eXtensible Markup Language), 是一种标记语言. - 标记型语言: 使用标签进行操作 - 可扩展: XML 的标签可以自定义 - ...
- C#中的另类语法
一..net中return的另类写法: 不知道是从3.5还是从4.0开始C#语法中的return有了新的写法示例如下: public string functionDemo() { str ...
- OVN实战---《The OVN Gateway Router》翻译
Overview 在本文中我将在前文的基础上添加一个OVN gateway router.gateway router将使得lab network能访问我们的overlay network The l ...
- CSDN编程挑战——《进制转换》
版权声明:本文为博主原创文章.未经博主同意不得转载. https://blog.csdn.net/user_longling/article/details/24804949 进制转换 题目详情: 我 ...
- Java泛型四:Java泛型总结
原文地址https://www.cnblogs.com/lwbqqyumidi/p/3837629.html 一. 泛型概念的提出(为什么需要泛型)? 首先,我们看下下面这段简短的代码: 1 publ ...
- begoo——路由设置
路由本质是URL与要为该URL调用的视图函数之间的映射表,其实就是你定义的使用那个URL调用那段代码的关系对应表. 首先看一下最简单的路由: package routers import ( &quo ...
- Python Tornado框架(ioloop对象分析)
网上都说nginx和lighthttpd是高性能web服务器,而tornado也是著名的高抗负载应用,它们间有什么相似处呢?上节提到的ioloop对象是如何循环的呢?往下看. 首先关于TCP服务器的开 ...